include <imhdr.h>

task imp = t_imp,
     exp = t_exp

define	XDIM		512
define	YDIM		512
define	ZDIM		3
define	SZ_CACHE	16


procedure t_exp ()

pointer	im, immap(), imgl3r()
pointer	p[ZDIM], ptr
int	i, j

begin
	im = immap ("foo", READ_ONLY, 0)

	do i = 1, ZDIM {
	    call malloc (p[i], XDIM, TY_REAL)
	    call amovkr (real(i), Memr[p[i]], XDIM)
	}

	# The slow way to do it: 16.9 real 0.7 user 14.8 sys
#	do i = 1, YDIM {
#	    do j = 1, ZDIM {
#		ptr = imgl3r (im, i, j)
#		call amovr (Memr[ptr], Memr[p[j]], XDIM)
#	    }
#	}

	# The fastest way to do it: 1.2 real 0.4 user 0.7 sys
	do i = 1, ZDIM {
	    do j = 1, YDIM {
		ptr = imgl3r (im, j, i)
		call amovr (Memr[ptr], Memr[p[i]], XDIM)
	    }
	}

	do i = 1, ZDIM
	    call mfree (p[i], TY_REAL)
	call imunmap (im)
end

procedure t_imp ()

pointer	im, immap(), impl3r(), imps3r()
pointer	p[ZDIM], ptr
int	i, j, line

begin
	im = immap ("foo", NEW_IMAGE, 0)
	IM_LEN(im,1) = XDIM
	IM_LEN(im,2) = YDIM
	IM_LEN(im,3) = ZDIM
	IM_NDIM(im) = 3
	IM_PIXTYPE(im) = TY_REAL

	do i = 1, ZDIM {
	    call malloc (p[i], XDIM*SZ_CACHE, TY_REAL)
	    call amovkr (real(i), Memr[p[i]], XDIM)
	}

	# The slow way to do it: 47.0 real 0.9 user 35.1 sys  
#	do i = 1, YDIM {
#	    do j = 1, ZDIM {
#		ptr = impl3r (im, i, j)
#		call amovr (Memr[p[j]], Memr[ptr], XDIM)
#	    }
#	}

	# Buffer 16 lines at a time from each band before writing it out.
	# The faster way to do it: 3.1 real 1.0 user 1.4 sys
#	do i = 1, ZDIM {
#	    line = 1
#	    do j = 1, YDIM {
#	        call amovkr (real(i), Memr[p[i]+((line-1)*XDIM)], XDIM)
#
#		if (line >= SZ_CACHE || j == YDIM) {
#		    ptr = imps3r (im, 1, XDIM, (j-SZ_CACHE+1), j, i, i)
#		    call amovr (Memr[p[i]], Memr[ptr], XDIM*min(SZ_CACHE,j))
#		    line = 1
#		} else
#		    line = line + 1
#	    }
#	}

	# The fastest way to do it: 2.9 real 0.5 user 1.4 sys
	do i = 1, ZDIM {
	    do j = 1, YDIM {
		ptr = impl3r (im, j, i)
		call amovr (Memr[p[i]], Memr[ptr], XDIM)
	    }
	}

	do i = 1, ZDIM
	    call mfree (p[i], TY_REAL)
	call imunmap (im)
end
